/* This is the frame showing the chopping file Options.
 */

// importing appropiate packages
import javax.swing.JInternalFrame;
import javax.swing.JDesktopPane;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
//import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import java.io.File;
import java.io.IOException;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.text.DecimalFormat;

public class choppFrame extends JInternalFrame implements ActionListener, constants {

        // the buttons
        private JButton passBtn = null;
        private JButton applyBtn = null;
        private JButton cancelBtn = null;
        private JButton helpBtn = null;
        private JButton selectBtn = null;

        // the labels
        private JLabel imageLabel = null;
        private JLabel fileNameLabel = null;
        private JLabel fileSizeLabel = null;
        private JLabel fileDescLabel = null;
        private JLabel segFileLabel = null;
        private JLabel choppTypeLabel = null;

        private JTextField segFileText = null;

        // the radio buttons
        private JRadioButton cmfRadioBtn = null;
        private JRadioButton batRadioBtn = null;

        // the GUI Desiging components
        private BorderLayout mainLayout = null;
        private Container fullWin = null;
		
//		private progressThread pt = null;
		
		private JDesktopPane parent = null; 
		private fileChopper fc = null;
		private File fname = new File( "c:\\red.mp3" );

		private mProgressFrame progressBar;
		
        public choppFrame(JDesktopPane jdp, File f)
        {
            super("Chopp a file", true, false, false, true );
            parent = jdp;
        	fname = f;
            setComponents();
        }
        
/*        public choppFrame()
        {
            super("Chopp a file");
//            parent = jdp;
  //      	fname = f;
            setComponents();
        }
*/

        private void setComponents()	{
            	initComponents();

                mainLayout = new BorderLayout();

                Container fullWin = getContentPane();
                fullWin.setLayout( mainLayout );
                fullWin.setBackground( bgColor );

                JPanel topRightPanel = new JPanel();
                topRightPanel.setBackground( bgColor );
                topRightPanel.setLayout( new GridLayout(3,1, 5, 10) );
                topRightPanel.add( fileNameLabel );
                topRightPanel.add( fileSizeLabel );
                topRightPanel.add( fileDescLabel );

                JPanel topPanel = new JPanel();
                topPanel.setLayout( new FlowLayout(FlowLayout.LEFT, 5, 5 ) );
                topPanel.setBackground( bgColor );
                topPanel.add( imageLabel );
                topPanel.add( topRightPanel );

                JPanel segPanel = new JPanel();
                segPanel.setBackground( bgColor );
                segPanel.setLayout( new FlowLayout( FlowLayout.LEFT) );
                segPanel.add( segFileLabel );
                segPanel.add( segFileText );

                JPanel midPanel = new JPanel();
                midPanel.setBackground( bgColor );
                midPanel.setLayout( new GridLayout(4, 1) );
                midPanel.add( segPanel );
                midPanel.add( choppTypeLabel );
                midPanel.add( cmfRadioBtn );
                midPanel.add( batRadioBtn );

                // This Panel holds all the operational Button
                JPanel btnPanel = new JPanel();
                btnPanel.setLayout( new GridLayout(1,3, 10, 10) );
                btnPanel.setBackground( bgColor );
           //     btnPanel.add( passBtn );
                btnPanel.add( applyBtn );
                btnPanel.add( cancelBtn );
                btnPanel.add( helpBtn );
	

                fullWin.add( topPanel, BorderLayout.NORTH );
                fullWin.add( midPanel, BorderLayout.CENTER );
                fullWin.add( btnPanel, BorderLayout.SOUTH );

                setSize( 350, 240 );
                setVisible( true );

        }


        private void initComponents()
        {
        		passBtn = new JButton("Password");
                passBtn.addActionListener( this );

                applyBtn = new JButton("Apply");
                applyBtn.addActionListener( this );

                cancelBtn = new JButton("Cancel");
                cancelBtn.addActionListener( this );

                helpBtn = new JButton("Help");
                helpBtn.addActionListener( this );

       //         selectBtn = new JButton("Select");
         //       selectBtn.addActionListener( this );

                cmfRadioBtn = new JRadioButton(" CMF Format file ");
                cmfRadioBtn.setBackground( bgColor );
                
                batRadioBtn = new JRadioButton(" Batch/EXE File ");
				batRadioBtn.setBackground( bgColor );
				batRadioBtn.setSelected( true );

                imageLabel = new JLabel( new ImageIcon( folder + "chopp.jpg") );
                applyLabelProperty( imageLabel );
				
				ButtonGroup bg = new ButtonGroup();
				bg.add( cmfRadioBtn );
				bg.add( batRadioBtn );
				
                fileNameLabel = new JLabel( "File Name: " + fname.getName() );
                applyLabelProperty( fileNameLabel );

                fileSizeLabel = new JLabel( "File Size: " + calcFileSize( (double)fname.length() ) );
                applyLabelProperty( fileSizeLabel );

                String desc = fname.getName().substring( 
                				fname.getName().lastIndexOf( '.') + 1, 
                				fname.getName().length()  ) ;
                
                fileDescLabel = new JLabel( "Description: " + desc + " File");
                applyLabelProperty( fileDescLabel );

                choppTypeLabel = new JLabel(" Chopping Options : ");
                applyLabelProperty( choppTypeLabel );

                segFileLabel = new JLabel("Enter the Total Segments: ");
                applyLabelProperty( segFileLabel );

                segFileText = new JTextField(7);        		
        }
        
        private String calcFileSize( double size )
        {
        	DecimalFormat form = new DecimalFormat("#0.00");
        	if( size > 1024.0 && size < 1024.0*1024.0) 
        		return String.valueOf( form.format(size/1024.0) ) + " KB";
        	
        	else if( size >= 1024.0*1024.0 && size < 1024.0*1024.0*1024.0 )
        		return String.valueOf( form.format(size/(1024.0*1024.0) ) ) + " MB";
        	
        	else if( size >= 1024.0*1024.0*1024.0 )
        		return String.valueOf( form.format(size/(1024.0*1024.0*1024.0) ) ) + " GB" ;
        	else
        		return String.valueOf( size ) + " Bytes";
        }
        		 

        private void applyLabelProperty( JLabel jc )
        {
                jc.setBackground( bgColor );
                jc.setForeground( fontColor );
                jc.setFont( labelFont );
        }

        public void actionPerformed( ActionEvent e1 )
        {
			if( e1.getSource() == applyBtn )	{
			    boolean success = false;
			    boolean error = false;
			    // check for valid Entry in 
			    try {
			    	String temp = segFileText.getText();
			    	int number = Integer.parseInt( temp );
			    	if( number > 1 && number < 500 )	{
			    			
			    			if( number*2 < (int)fname.length() )
			    			{
			    				fc = new fileChopper( fname, number);
								progressBar = new mProgressFrame();
								parent.add( progressBar );
//								parent.setSelectedFrame( progressBar );
								parent.setSelectedFrame( progressBar );
								parent.moveToFront( progressBar );
								progressBar.show();
//								System.out.println( parent.getAllFrames() );
								if( cmfRadioBtn.isSelected() )	{			    	
			    					progressBar.setMaximum( fc.getMaxValue() );
			    					success = fc.applyChopper( constants.OBJECT_FILE, progressBar );
			    				}
			    				else if( batRadioBtn.isSelected() ) {
			    					progressBar.setMaximum( fc.getMaxValue() );
			    					success = fc.applyChopper( constants.BATCH_FILE, progressBar );
			    				}
			    				else
			    					JOptionPane.showMessageDialog( null, 
									" Please Select any of the 2 options ", " No Option Selected ", 2);
			    			}
			    			else {
			    					JOptionPane.showMessageDialog( null, 
									" File Segment too Small ", " Error in File Chopping ", 2);
			    			}			    				
			    	}
			    	else	{
			    		
			    		JOptionPane.showMessageDialog( null, 
						" Number Should be between 1 And 500 ", " Invalid Entry", 2);
			    		
			    	}
			    }
			    catch(NumberFormatException nfe1 )
			    {
			    	JOptionPane.showMessageDialog( this, "Enter a Valid Integer in segment Field ", 
			    						"Invalid Entry", 2 );
			    	error = true;
			    }
				
				if( success && !error)	
					JOptionPane.showMessageDialog( null,
						"File Successfully Chopped", "Success", 
						1 );
				
				else if( !success && !error )
					JOptionPane.showMessageDialog( null,
						fc.getErrorMessage(), "Error Occured", 2 );
						
//				if( pt != null )	{
//					pt.end();
//					pt = null;
//				}
	
				if( !error )	{
					progressBar.setVisible(false);
					this.setVisible( false );
					parent.remove( progressBar );
					parent.remove( this );
				}
				
			}
			
			if( e1.getSource() == cancelBtn )
			{
				this.setVisible( false );
				parent.remove( this );
			}
			
			if( e1.getSource() == helpBtn )
			{
				JOptionPane.showMessageDialog( null,
					" Specify the number of segments(splitted files)\n\n " + 
					" Then Choose any of the Chopping Option \n" +
					" 1. A CMF OPtion gives the advantage of Password \n" +
					" 2. A Batch File Gives u the benefit that the other \n" + 
					"    user doesnot need this program to combine."
					 , "Help Needed", 3 );								
			}
        }

	

	
 /*  		public static void main( String arghs[])
        {
                new choppFrame();
        }

/*	
		private class progressThread implements Runnable {
			
			private volatile boolean isRunning = true;
			
			public void run() {
				
				while( isRunning )
				{
					try {
						int timer = fc.getCurrentValue();
						progressBar.setValue( timer );
						if( timer == fc.getMaxValue() )	{
							progressBar.setValue( timer );							
							end();
						}
						Thread.sleep(400);	
						System.out.println("Running");
					}
					catch( InterruptedException ie1 )	{		}
				}
			}
			
			public void end()
			{
				isRunning = false;
			}
		}
*/					 
						
						

}
