

import javax.swing.JInternalFrame;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;

public class fileChopper implements constants{
	
	private File file = null;
	private String fileType = null;
	private String fileFolder = null;
	private String folderExt = "_fcp";
	private long fileSize = 0;


	private int totalSegment = 0;
	private final int minFileSize = 1024;	
	
	private String[] segmentFileName = null;
	private long[] segmentFileSize = null;
	private final int NO_ERROR = -1;
	private final String[] errorMess = {
		"Input File Not Found",
		"Unable to write in Output File",
		"Unknown Error. Please Restart"
	};
		
	private int currentValue;	
	private int errorCode = NO_ERROR;
	private chopperData fdata = null;
	private fileHandler fH;

	public fileChopper( String name, int t_seg )
	{
		this.file = new File( name );
		this.totalSegment = t_seg;
		initValues();
	}
	
	public fileChopper( File f , int t_seg )
	{
		this.file = f;
		this.totalSegment = t_seg;
		initValues();
	}		

	// this method initializes all the variable values.	
	private void initValues()
	{
		fileSize = file.length();
		fileType = file.getName().substring( 0, file.getName().lastIndexOf('.') ) + "File";
		
		long blockSize = fileSize/totalSegment;
		long remain = fileSize;
		
		fileFolder = file.getAbsolutePath() + folderExt + "\\";
		
//		long total=0;
//		System.out.println( fileSize );
		
		this.segmentFileName = new String[this.totalSegment];
		this.segmentFileSize = new long[this.totalSegment];
		for( int i=0; i < totalSegment; i ++ )
		{
			this.segmentFileName[i] = file.getName() + "_" + Integer.toString(i+1) + choppFileExt;
			if( i == totalSegment - 1 )
				this.segmentFileSize[i] = remain;				
			else
				this.segmentFileSize[i] = blockSize;
			
			remain -= blockSize;
//			total+= segmentFileSize[i];
//			System.out.println( remain );
//			System.out.println( segmentFileSize[i] + " Name : " + segmentFileName[i] );		
		}
//		System.out.println( total );					
	}
	
	private boolean ChoppFile( mProgressFrame jp ) 
	{
		FileInputStream fis = null;
		FileOutputStream out = null;
		byte[] dataBlock= null;
		
		try { 
			errorCode = NO_ERROR+1;
			fis = new FileInputStream( file );

//			System.out.println( fileFolder
			new File( fileFolder  ).mkdir();
			errorCode = NO_ERROR+2;			
			for( int i=0; i < totalSegment; i++ )
			{
				jp.setValue(i);
				
				out = new FileOutputStream( fileFolder + segmentFileName[i] );
				dataBlock = new byte[ (int)segmentFileSize[i] ];
				fis.read( dataBlock );
				out.write( dataBlock );
				out.close();
			}
			
			fis.close();
			errorCode = NO_ERROR;
		}
		catch( IOException ioe )	{
		
		}
		return (errorCode == NO_ERROR);
	}
	
	public String getErrorMessage()
	{
		if( errorCode != NO_ERROR )
			return errorMess[ errorCode ];
		return "No Error Occured";
	}
	
/*	public int getCurrentValue()
	{
		return this.currentValue;
	}
*/	
	public int getMaxValue()
	{
		return this.totalSegment;
	}
	
	public boolean applyChopper(int choice, mProgressFrame jp)
	{	
		if( ChoppFile(jp) )	{
			fdata = new chopperData( file.getName(), segmentFileName, segmentFileSize );
			fH = new fileHandler( fdata );
//			System.out.println( fileFolder + file.getName() + batchFileExt );
			
			if( choice == OBJECT_FILE )
				return fH.writeObjectFile( fileFolder + file.getName() + objectFileExt );
			
			else if( choice == BATCH_FILE )
				return  fH.writeBatchFile( fileFolder + file.getName() + batchFileExt );
		}
		else
			return false;
	
		return true;
	}
	 
		
/*
	public static void main( String args[]) 
	{
		File f = new File("tutorial.zip");
		System.out.println( f.exists() );
		System.out.println( f.getAbsolutePath() );
		System.out.println( f.length() );
		fileChopper fc = new fileChopper( f, 2 );
		System.out.println( fc.applyChopper(constants.BATCH_FILE) );
		System.out.println( fc.getErrorMessage() );		
	 }

*/
}