
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class fileCombiner implements constants {
	
	private chopperData cData;
	private fileHandler fc;
	private String errorMess;
	
	public fileCombiner() {
	
		this.fc = new fileHandler();
		this.errorMess = null;
	}
	
	public boolean applyCombiner( File infile )
	{
//		System.out.println( infile.exists() );
		cData = fc.readObjectFile( infile );
		
		if( cData != null )	{
//			System.out.println( infile.getParent() + "\\" + cData.getSegFileNames()[0] );
		}
		
		String[] fileList = cData.getSegFileNames();		
		
		if( checkAllFiles( infile.getParent(), fileList) )	
			return combineFile( infile.getParent(), fileList );
		
		return false;
	}
	
	private boolean checkAllFiles( String root, String[] fileList )
	{

		for( int i=0; i < fileList.length; i++ )	{
			errorMess = "File DoesNot Exist, " + fileList[i];
			if( !(new File( root + "\\" + fileList[i] ) ).exists() )
				return false;
		}
		
		errorMess = "none";
		return true;
	}
	
	public String getErrorMessage()	{
		return errorMess;
	}
	
	private boolean combineFile( String dir, String[] fileList )
	{
		try {	
			FileInputStream fis = null;
			FileOutputStream fos = new FileOutputStream( dir + "\\" + cData.getFileName() ); 
			byte[] dataBlock = null;
			for( int i=0; i < fileList.length; i++ )	{
				errorMess = "Unable to read from file " + fileList[i] ;
				
				fis = new FileInputStream( dir + "\\" + fileList[i] );
				dataBlock = new byte[ (int)(cData.getSegFileSize())[i] ];
				
				fis.read( dataBlock );
				fos.write( dataBlock );
				
				fis.close();
			}
			errorMess = "Unable to Close File " + cData.getFileName() ;
			fos.close();
			
			errorMess = "none";			
			return true;
		}
		catch( IOException ioe1 )	{		}
			return false;
		
	}
/*	
	public static void main(String args[])
	{
		fileCombiner fc = new fileCombiner();
		System.out.println( fc.applyCombiner(new File(
			"H:\\Javadoc\\FileChopper\\ashik.psd_fcp\\ashik.psd.cmf") )
			 );
			 
		System.out.println( fc.getErrorMessage() );
	}

*/		
}
	