/* 
 *  File Chopper v1.0
 *  -------------------
 *  ALIF
 *  Date: 2/02/05
 *  Email : aliffbd@yahoo.com
 * ---------------------------
 * 
 * 
 * This Program Splits a large File into a Smaller files..
 * The advantage of this Program.. is that.. the Other User doesnot need
 * this program to combine the Files.
 * 
 *
 * This is the MAIN CLASS.. of the Application...
 * 
 * ----------------------------------------------------------------
 * The Following files/class are needed for the Program to run
 *
 *		1.  constants.java
 *		2.  fileChopper.java
 *		3.  fileCombiner.java
 *		4.  chopperData.java
 *		5.  fileHandler.java
 *		6.  choppFrame.java
 *		7.  combineFrame.java
 *		8.  helpFrame.java
 *		9. cmfFilter.java
 *
 *------------------------------------------------------------------
 */
 
		

// importing appropiate packages
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JDesktopPane;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;

import javax.swing.UIManager;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.ImageIcon;

import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


// this class it the main Class of the Entire Application..
public class mainFrame extends JFrame implements ActionListener, constants {
	
	// this desktopPane holds all the frames.. 
	private JDesktopPane mainDesktop = null;
	
	// the main Menu Bar..
	private JMenuBar menuBar = null;
	private JMenu[]	 menu = null;
	private JMenuItem[]  menuItem = null;
	private Container fullWin = null;
	
	private int WIDTH = 640;
	private int HEIGHT = 480;
	
	// the different Inside Windows...
	private choppFrame choppWin   = null;
	private helpFrame helpWin    = null;
	
	private fileCombiner fComb = null; 
	private JFileChooser jfc = null;

	private UIManager.LookAndFeelInfo looks[];			
	
	public mainFrame()
	{
		super("JFile Chopper v1.0 ALPHA");
		fullWin = getContentPane();
		this.setDefaultLookAndFeelDecorated( true );
		setComponents();
		looks = UIManager.getInstalledLookAndFeels();		
	}
	
	
	private void setComponents() 	{
		
		// init the main Desktop.. this holds all the inside windows...
		mainDesktop = new JDesktopPane();
		fullWin.add( mainDesktop );
		
		// settting the menu bars, menu Items..
		menuBar = new JMenuBar();
		menu = new JMenu[menuText.length];
		
		// setting the top menus
		for( int i=0; i <  menu.length; i++	)	{
			menu[i] = new JMenu( menuText[i][0] );
			menuBar.add( menu[i] );
		}		
		
		// setting the items of each Menus..
		menuItem = new JMenuItem[ menuText[0].length*2 ] ;
		for( int i=0; i < menu.length; i++ )	{
			for( int j=1; j < menuText[0].length; j++ )	{
				menuItem[j] = new JMenuItem( menuText[i][j], new ImageIcon( 
							 				folder + menuText[i][j]+".gif") 
							 			   ); 
							 			    
				menuItem[j].setFont( menuFont );
				menu[i].add( menuItem[j] );
				menuItem[j].addActionListener( this );				
				
				if( j == menuText[0].length-2 && i != 1 )
					menu[i].addSeparator();
			}
		}
		
		setJMenuBar( menuBar );
		setSize( WIDTH , HEIGHT );
		setVisible( true );
	}
	
	// event handling method..
	public void actionPerformed( ActionEvent event )	{
	
		String cmd = event.getActionCommand();

		// if user hits the chopp Menu Item..
		if( cmd.equals( menuText[0][1] ) )	 {
//			choppWin = new choppFrame();
//			mainDesktop.add( choppWin );
			jfc = new JFileChooser();
			jfc.setBackground( bgColor );
			int value = jfc.showDialog( this, "Select" );						
			
			java.io.File tmpFile = jfc.getSelectedFile();
			if( value == JFileChooser.APPROVE_OPTION )	{
				if( tmpFile.getName().endsWith(".cmf") || tmpFile.getName().endsWith(".cpf") )
					JOptionPane.showMessageDialog( null, 
						" This is already a Chopped File ", " Error in Chopping ", 1 );
				else {				
					choppWin = new choppFrame( mainDesktop, tmpFile );
					mainDesktop.add( choppWin );
				}
			}
		}

		// if user hits the Combine Menu Item..		
		if( cmd.equals( menuText[0][2] ) ) {
			
			jfc = null;
			jfc = new JFileChooser();
			jfc.addChoosableFileFilter( new cmfFilter() );
//			jfc.setFileFilter( new cmfFilter() );
			jfc.showDialog( this, "Select"); 
			
			java.io.File selectedFile = jfc.getSelectedFile();
			if( selectedFile != null )
			{
				if( selectedFile.getName().endsWith(".cmf") ||
					selectedFile.getName().endsWith(".CMF") )
				{
					fComb = new fileCombiner();
					if( fComb.applyCombiner( selectedFile ) )
						JOptionPane.showMessageDialog( null,
							"File Combining Successful", "Success", 1 );
					else
						JOptionPane.showMessageDialog( null,
							fComb.getErrorMessage(), "Error Occured", 2 );
				}
				else
					JOptionPane.showMessageDialog( null,
						"The Selected File is Not a Valid One",
						"Wrong File Type Selected",	JOptionPane.ERROR_MESSAGE );
			}
		}
		
		// if user hits the EXIT Menu Item..
		if( cmd.equals( menuText[0][3] ) ) {
			mainDesktop.removeAll();
			System.exit(1);
		}
		
		if( cmd.equals( menuText[1][1] ) ) {
			if( !changeTheStyle( constants.JAVA_SWING_STYLE ) ) 
				JOptionPane.showMessageDialog( null,
					"Error Occured in Changing the Skin", "Error Occured", 2 );
		}	

		if( cmd.equals( menuText[1][2] ) ) {
			if( !changeTheStyle( constants.SCO_UNIX_STYLE ) ) 
				JOptionPane.showMessageDialog( null,
					"Error Occured in Changing the Skin", "Error Occured", 2 );
		}	

		
		if( cmd.equals( menuText[1][3] ) ) {
			if( !changeTheStyle( constants.WINDOWS_STYLE ) ) 
				JOptionPane.showMessageDialog( null,
					"Error Occured in Changing the Skin", "Error Occured", 2 );
		}	
		


		// if user hits the HELP Menu Item..		
		if( cmd.equals( menuText[2][1] ) ) {
//			System.out.println(" Reached");
			helpWin = new helpFrame( mainDesktop );
			mainDesktop.add( helpWin );
		}

		// if user hits the Products Menu Item..				
		if( cmd.equals( menuText[2][2] ) ) {
			JOptionPane.showMessageDialog( null,
			"Things i am Working-on now" +
			"\n 1. Password Protected chopped file" ,
			"More Information", 1 );
					
		}

		// if user hits the About Menu Item..				
		if( cmd.equals( menuText[2][3] ) ) {
			JOptionPane.showMessageDialog( null, 
				" JFile Chopper v1.0 \n Created by alif, Jan 2005\n " +
				"\n For Any suggestions: \n Email me: aliffbd@yahoo.com",
				"About the Creator", 1 ); 
		}
	}
	
	private boolean changeTheStyle( int value )
	{
		try {
			// SET THE NEW LOOK AND FEEL
			UIManager.setLookAndFeel( looks[value].getClassName() );
			javax.swing.SwingUtilities.updateComponentTreeUI( this ); // UPDATE THE NEW PATH
			return true;
		}
		catch( ClassNotFoundException e1 ) {	}
		catch( InstantiationException e1 ) {	}
		catch( IllegalAccessException e1 ) {	}			
		catch( javax.swing.UnsupportedLookAndFeelException e1 ) {	}			
		return false;
	}		
	
	
	public static void main(String args[])	{
		mainFrame mf = new mainFrame();
		mf.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
	}
}